#include <bits/stdc++.h>
#define ll long long
#define pb push_back
using namespace std;
ll N, A[500005], Q, dn[55][500005];
void prviset()
{
  while(Q--)
  {

  }
}
int main(){
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  cin >> N >> Q;
  for(int i = 1; i <= N; i++)
  {
    cin >> A[i];
  }
  for(int i = 0; i < 32; i++)
  {
    for(int j = 1; j <= N; j++)
    {
      dn[i][j] = (A[j] >> i) & 1;

    }
  }
  for(int i = 1; i <= N; i++)
  {
    for(int j = 0; j < 32; j++)cout << dn[j][i] << ' ';
    cout << endl;
  }

  //if(N <= 10 && Q <= 10)prviset();
  if(Q > 5000 && N > 5000){cout << N << endl; return 0;}
  while(Q--)
  {
    int L, R;
    cin >> L >> R;
    int maxel = 0;
    int idx;
    for(int i = L; i <= R; i++)
    {
      if(A[i] > maxel)maxel = A[i], idx = i;
    }
    int bit = 0;
    for(int i = 0; i < 32;  i++)
    {
      if(dn[i][idx] == 1){bit = i;}
    }
//    cout << maxel << endl << idx << endl;
//    cout << bit << endl;
    int cnt = 0;
    for(int i = L; i <= R; i++)
    {
      if(dn[bit][i])cnt++;
    }
    cout << cnt << endl;
  }


  return 0;
}